--
-- Author: SbSh
-- 3D model: BlackTiger
-- 12.12.22
-- 0.1.0.0
-- last edit: 13.04.2023
-- digitalPrizeSpezialisation.lua
--
-- ToDo:
-- 	Super simulated calculation
--  ClipDistance @Giants for fonts

-- Verwendung der Standard LS Waage Anzeige als Tankstellen-Display

DigitalPrizeSpezialisation = {
    Version = "0.1.0.0",
    Name = "DigitalPrizeSpezialisation"
}
print(g_currentModName .. " - init " .. DigitalPrizeSpezialisation.Name .. "(Version: " .. DigitalPrizeSpezialisation.Version .. ")");

function DigitalPrizeSpezialisation.prerequisitesPresent(specializations)
    return true;
end

function DigitalPrizeSpezialisation.registerEventListeners(placeableType)
	SpecializationUtil.registerEventListener(placeableType, "onLoad", DigitalPrizeSpezialisation);
	SpecializationUtil.registerEventListener(placeableType, "onMinuteChanged", DigitalPrizeSpezialisation);
end

function DigitalPrizeSpezialisation.registerFunctions(placeableType)
	SpecializationUtil.registerOverwrittenFunction(placeableType, "getNeedMinuteChanged", DigitalPrizeSpezialisation.getNeedMinuteChanged)
end

function DigitalPrizeSpezialisation:getNeedMinuteChanged()
	return true;
end

function DigitalPrizeSpezialisation.registerXMLPaths(schema, basePath)
	schema:setXMLSpecializationType("GasStationDisplay");
	schema:register(XMLValueType.NODE_INDEX, basePath .. ".GasStationDisplays.GasStationDisplay(?)#node", "Node");
	schema:register(XMLValueType.STRING, basePath .. ".GasStationDisplays.GasStationDisplay(?)#font", "Display font name");
	schema:register(XMLValueType.STRING, basePath .. ".GasStationDisplays.GasStationDisplay(?)#alignment", "Display text alignment");
	schema:register(XMLValueType.FLOAT, basePath .. ".GasStationDisplays.GasStationDisplay(?)#size", "Display text size");
	schema:register(XMLValueType.FLOAT, basePath .. ".GasStationDisplays.GasStationDisplay(?)#scaleX", "Display text x scale");
	schema:register(XMLValueType.FLOAT, basePath .. ".GasStationDisplays.GasStationDisplay(?)#scaleY", "Display text y scale");
	schema:register(XMLValueType.STRING, basePath .. ".GasStationDisplays.GasStationDisplay(?)#mask", "Display text mask");
	schema:register(XMLValueType.FLOAT, basePath .. ".GasStationDisplays.GasStationDisplay(?)#emissiveScale", "Display emissive scale");
	schema:register(XMLValueType.COLOR, basePath .. ".GasStationDisplays.GasStationDisplay(?)#color", "Display text color");
	schema:register(XMLValueType.COLOR, basePath .. ".GasStationDisplays.GasStationDisplay(?)#hiddenColor", "Display text hidden color");
	schema:register(XMLValueType.STRING, basePath .. ".GasStationDisplays.GasStationDisplay(?)#fillType", "Filltype name for the Display to show amount");
    
	schema:setXMLSpecializationType();
end

function DigitalPrizeSpezialisation:onLoad(savegame)
    self.spec_GasStationDisplay = {};
	local spec = self.spec_GasStationDisplay;
	local xmlFile = self.xmlFile;
	spec.GasStationDisplays = {};  -- diesel
	spec.GasStationDisplays2 = {}; -- diesel
	spec.GasStationDisplays3 = {}; -- super (simulated)
	spec.GasStationDisplays4 = {}; -- super (simulated)
	spec.GasStationDisplays5 = {}; -- gas
	spec.GasStationDisplays6 = {};  -- gas
	spec.GasStationDisplays7 = {}; -- elek
	spec.GasStationDisplays8 = {}; -- elek
	spec.GasStationDisplays9 = {}; -- def
	spec.GasStationDisplays10 = {}; -- def
	local i = 0;

	while true do
		local PrDispKey = string.format("placeable.GasStationDisplays.GasStationDisplay(%d)", i);
		if not xmlFile:hasProperty(PrDispKey) then
			break;
		end
        
		local PrDispNode = self.xmlFile:getValue(PrDispKey .. "#node", nil, self.components, self.i3dMappings);
        -- print("PrDispNode: ".. tostring(PrDispNode))
        local fontName = self.xmlFile:getValue(PrDispKey .. "#font", "DIGIT_BOLD"):upper();
        local fontMaterial = g_materialManager:getFontMaterial(fontName, self.customEnvironment);
            
        local GasStationDisplay = {};
        local GasStationDisplay2 = {};
        local GasStationDisplay3 = {};
        local GasStationDisplay4 = {};
        local GasStationDisplay5 = {};
		local GasStationDisplay6 = {};
        local GasStationDisplay7 = {};
        local GasStationDisplay8 = {};
        local GasStationDisplay9 = {};
        local GasStationDisplay10 = {};
		
        local alignmentStr = self.xmlFile:getValue(PrDispKey .. "#alignment", "LEFT");
        local alignment = RenderText["ALIGN_" .. alignmentStr:upper()] or RenderText.ALIGN_CENTER;
        local size = self.xmlFile:getValue(PrDispKey .. "#size", 0.35);
        -- local clipD = self.xmlFile:getValue(PrDispKey .. "#clipDistance", 120);
        local scaleX = self.xmlFile:getValue(PrDispKey .. "#scaleX", 1);
        local scaleY = self.xmlFile:getValue(PrDispKey .. "#scaleY", 1.2);
        local mask = self.xmlFile:getValue(PrDispKey .. "#mask", "ff0000");
        local emissiveScale = self.xmlFile:getValue(PrDispKey .. "#emissiveScale", 0.4);
        local color = self.xmlFile:getValue(PrDispKey .. "#color", { 0.5, 0.5, 0.5, 1 }, true);
        local hiddenColor = self.xmlFile:getValue(PrDispKey .. "#hiddenColor", nil, true);
        GasStationDisplay.PrDispNode = PrDispNode;
        GasStationDisplay2.PrDispNode = PrDispNode;
        GasStationDisplay3.PrDispNode = PrDispNode;
        GasStationDisplay4.PrDispNode = PrDispNode;
        GasStationDisplay5.PrDispNode = PrDispNode;
        GasStationDisplay6.PrDispNode = PrDispNode;
        GasStationDisplay7.PrDispNode = PrDispNode;
        GasStationDisplay8.PrDispNode = PrDispNode;
        GasStationDisplay9.PrDispNode = PrDispNode;
        GasStationDisplay10.PrDispNode = PrDispNode;
		
        GasStationDisplay.formatStr, GasStationDisplay.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay2.formatStr, GasStationDisplay2.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay3.formatStr, GasStationDisplay3.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay4.formatStr, GasStationDisplay4.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay5.formatStr, GasStationDisplay5.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay6.formatStr, GasStationDisplay6.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay7.formatStr, GasStationDisplay7.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay8.formatStr, GasStationDisplay8.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay9.formatStr, GasStationDisplay9.formatPrecision = string.maskToFormat(mask);
        GasStationDisplay10.formatStr, GasStationDisplay10.formatPrecision = string.maskToFormat(mask);
		
        GasStationDisplay.fontMaterial = fontMaterial;
        GasStationDisplay2.fontMaterial = fontMaterial;
        GasStationDisplay3.fontMaterial = fontMaterial;
        GasStationDisplay4.fontMaterial = fontMaterial;
        GasStationDisplay5.fontMaterial = fontMaterial;
        GasStationDisplay6.fontMaterial = fontMaterial;
        GasStationDisplay7.fontMaterial = fontMaterial;
        GasStationDisplay8.fontMaterial = fontMaterial;
        GasStationDisplay9.fontMaterial = fontMaterial;
        GasStationDisplay10.fontMaterial = fontMaterial;
		
        GasStationDisplay.characterLine = fontMaterial:createCharacterLine(GasStationDisplay.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay2.characterLine = fontMaterial:createCharacterLine(GasStationDisplay2.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay3.characterLine = fontMaterial:createCharacterLine(GasStationDisplay3.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay4.characterLine = fontMaterial:createCharacterLine(GasStationDisplay4.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay5.characterLine = fontMaterial:createCharacterLine(GasStationDisplay5.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay6.characterLine = fontMaterial:createCharacterLine(GasStationDisplay6.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay7.characterLine = fontMaterial:createCharacterLine(GasStationDisplay7.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay8.characterLine = fontMaterial:createCharacterLine(GasStationDisplay8.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay9.characterLine = fontMaterial:createCharacterLine(GasStationDisplay9.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
        GasStationDisplay10.characterLine = fontMaterial:createCharacterLine(GasStationDisplay10.PrDispNode, mask:len(), size, color, hiddenColor, emissiveScale, scaleX, scaleY, alignment);
		
        if i == 0 then
			table.insert(spec.GasStationDisplays, GasStationDisplay);
		elseif i == 1 then
			table.insert(spec.GasStationDisplays2, GasStationDisplay2);
		elseif i == 2 then
			table.insert(spec.GasStationDisplays3, GasStationDisplay3);
		elseif i == 3 then
			table.insert(spec.GasStationDisplays4, GasStationDisplay4);
		elseif i == 4 then
			table.insert(spec.GasStationDisplays5, GasStationDisplay5);
		elseif i == 5 then
			table.insert(spec.GasStationDisplays6, GasStationDisplay6);
		elseif i == 6 then
			table.insert(spec.GasStationDisplays7, GasStationDisplay7);
		elseif i == 7 then
			table.insert(spec.GasStationDisplays8, GasStationDisplay8);
		elseif i == 8 then
			table.insert(spec.GasStationDisplays9, GasStationDisplay9);
		elseif i == 9 then
			table.insert(spec.GasStationDisplays10, GasStationDisplay10);
		end
		i = i + 1;
	end
 	spec.hasPrDisps = #spec.GasStationDisplays > 0
end

function DigitalPrizeSpezialisation:onMinuteChanged()
	local spec = self.spec_GasStationDisplay;
	if spec.hasPrDisps then
		local funitDiesel = g_fillTypeManager:getFillTypeByName("DIESEL")
		local funitSuper = funitDiesel.pricePerLiter + 0.131 *0.9666633
		local funitGas = g_fillTypeManager:getFillTypeByName("METHANE")
		local funitElek = g_fillTypeManager:getFillTypeByName("ELECTRICCHARGE")
		local funitDef = g_fillTypeManager:getFillTypeByName("DEF")
		
		local vGas = "-.---"
		local vElCh = "-.---"
		local vDEF = "-.---"
		
		local vDiesel = string.format("%.3f",funitDiesel.pricePerLiter)
		local vSuper = string.format("%.3f",funitSuper)
		if funitGas.pricePerLiter ~= nil and funitGas.pricePerLiter ~= 0 then
			vGas = string.format("%.3f",funitGas.pricePerLiter)
		else
			vGas = "8.888"
		end
		if funitElek.pricePerLiter ~= nil and funitElek.pricePerLiter ~= 0 then
			vElCh = string.format("%.3f",funitElek.pricePerLiter)
		else
			vElCh = "8.888"
		end
		
		if funitDef.pricePerLiter ~= nil and funitDef.pricePerLiter ~= 0 then
			vDEF = string.format("%.3f",funitDef.pricePerLiter)
		else
			vDEF = "8.888"
		end
		
		for _, GasStationDisplay in pairs(spec.GasStationDisplays) do
				GasStationDisplay.fontMaterial:updateCharacterLine(GasStationDisplay.characterLine, vDiesel);
		end
		for _, GasStationDisplay2 in pairs(spec.GasStationDisplays2) do
				GasStationDisplay2.fontMaterial:updateCharacterLine(GasStationDisplay2.characterLine, vDiesel);
		end
		for _, GasStationDisplay3 in pairs(spec.GasStationDisplays3) do
				GasStationDisplay3.fontMaterial:updateCharacterLine(GasStationDisplay3.characterLine, vSuper);
		end
		for _, GasStationDisplay4 in pairs(spec.GasStationDisplays4) do
				GasStationDisplay4.fontMaterial:updateCharacterLine(GasStationDisplay4.characterLine, vSuper);
		end
		for _, GasStationDisplay5 in pairs(spec.GasStationDisplays5) do
				GasStationDisplay5.fontMaterial:updateCharacterLine(GasStationDisplay5.characterLine, vGas);
		end
		for _, GasStationDisplay6 in pairs(spec.GasStationDisplays6) do
				GasStationDisplay6.fontMaterial:updateCharacterLine(GasStationDisplay6.characterLine, vGas);
		end
		for _, GasStationDisplay7 in pairs(spec.GasStationDisplays7) do
				GasStationDisplay7.fontMaterial:updateCharacterLine(GasStationDisplay7.characterLine, vElCh);
		end
		for _, GasStationDisplay8 in pairs(spec.GasStationDisplays8) do
				GasStationDisplay8.fontMaterial:updateCharacterLine(GasStationDisplay8.characterLine, vElCh);
		end
		for _, GasStationDisplay9 in pairs(spec.GasStationDisplays9) do
				GasStationDisplay9.fontMaterial:updateCharacterLine(GasStationDisplay9.characterLine, vDEF);
		end
		for _, GasStationDisplay10 in pairs(spec.GasStationDisplays10) do
				GasStationDisplay10.fontMaterial:updateCharacterLine(GasStationDisplay10.characterLine, vDEF);
		end
	end
end